package java.io;

import java.lang.reflect.Constructor;
import java.lang.reflect.Member;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.Arrays;
import java.util.Comparator;

class ObjectStreamClass$MethodSignature implements Comparator {
   Member member;
   String signature;

   static ObjectStreamClass$MethodSignature[] removePrivateAndSort(Member[] var0) {
      int var1 = 0;

      for(int var2 = 0; var2 < var0.length; ++var2) {
         if (!Modifier.isPrivate(var0[var2].getModifiers())) {
            ++var1;
         }
      }

      ObjectStreamClass$MethodSignature[] var3 = new ObjectStreamClass$MethodSignature[var1];
      int var4 = 0;

      for(int var5 = 0; var5 < var0.length; ++var5) {
         if (!Modifier.isPrivate(var0[var5].getModifiers())) {
            var3[var4] = new ObjectStreamClass$MethodSignature(var0[var5]);
            ++var4;
         }
      }

      if (var4 > 0) {
         Arrays.sort(var3, var3[0]);
      }

      return var3;
   }

   public int compare(Object var1, Object var2) {
      if (var1 == var2) {
         return 0;
      } else {
         ObjectStreamClass$MethodSignature var3 = (ObjectStreamClass$MethodSignature)var1;
         ObjectStreamClass$MethodSignature var4 = (ObjectStreamClass$MethodSignature)var2;
         int var5;
         if (this.isConstructor()) {
            var5 = var3.signature.compareTo(var4.signature);
         } else {
            var5 = var3.member.getName().compareTo(var4.member.getName());
            if (var5 == 0) {
               var5 = var3.signature.compareTo(var4.signature);
            }
         }

         return var5;
      }
   }

   private boolean isConstructor() {
      return this.member instanceof Constructor;
   }

   private ObjectStreamClass$MethodSignature(Member var1) {
      this.member = var1;
      if (this.isConstructor()) {
         this.signature = ObjectStreamClass.getSignature((Constructor)var1);
      } else {
         this.signature = ObjectStreamClass.getSignature((Method)var1);
      }

   }
}
